/********************************************************************************************
 *                                                                                          *
 * Copyright (C) 2017 Armin Felder, Dennis Beier                                            *
 * This file is part of RocketChatMobileEngine <https://git.fairkom.net/chat/fairchat>.     *
 *                                                                                          *
 * RocketChatMobileEngine is free software: you can redistribute it and/or modify           *
 * it under the terms of the GNU General Public License as published by                     *
 * the Free Software Foundation, either version 3 of the License, or                        *
 * (at your option) any later version.                                                      *
 *                                                                                          *
 * RocketChatMobileEngine is distributed in the hope that it will be useful,                *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of                           *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                            *
 * GNU General Public License for more details.                                             *
 *                                                                                          *
 * You should have received a copy of the GNU General Public License                        *
 * along with RocketChatMobileEngine. If not, see <http://www.gnu.org/licenses/>.           *
 *                                                                                          *
 ********************************************************************************************/



#include "emojirepo.h"

EmojiRepo::EmojiRepo()
{
    mElements.reserve( 3000 );
}

bool EmojiRepo::add( QSharedPointer<Emoji> pEmoji )
{
    return add( pEmoji->getIdentifier(), pEmoji );
}

bool EmojiRepo::add( QString pId, QSharedPointer<Emoji> pEmoji )
{
    if ( !pEmoji.isNull() ) {
        if ( !mEmojisOrdered.isEmpty() ) {
            if ( !pEmoji->getOrder() ) {
                pEmoji->setOrder( mEmojisOrdered.last()->getOrder() + 1 );
            }
        }

        mEmojisOrdered.insert( pEmoji->getOrder(), pEmoji );
        return AbstractBaseRepository::add( pId, pEmoji );
    } else {
        return false;
    }
}

QMap<int, QSharedPointer<Emoji> > EmojiRepo::emojisOrdered() const
{
    return mEmojisOrdered;
}
