/********************************************************************************************
 *                                                                                          *
 * Copyright (C) 2017 Armin Felder, Dennis Beier                                            *
 * This file is part of RocketChatMobileEngine <https://git.fairkom.net/chat/fairchat>.     *
 *                                                                                          *
 * RocketChatMobileEngine is free software: you can redistribute it and/or modify           *
 * it under the terms of the GNU General Public License as published by                     *
 * the Free Software Foundation, either version 3 of the License, or                        *
 * (at your option) any later version.                                                      *
 *                                                                                          *
 * RocketChatMobileEngine is distributed in the hope that it will be useful,                *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of                           *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                            *
 * GNU General Public License for more details.                                             *
 *                                                                                          *
 * You should have received a copy of the GNU General Public License                        *
 * along with RocketChatMobileEngine. If not, see <http://www.gnu.org/licenses/>.           *
 *                                                                                          *
 ********************************************************************************************/


#ifndef WEBSOCKETABSTRACT_H
#define WEBSOCKETABSTRACT_H

#include <QObject>
#include <QUrl>
#include <QString>
#include <QAbstractSocket>


class WebsocketAbstract: public QObject
{
        Q_OBJECT
    public:
        WebsocketAbstract( QObject *parent );

        virtual void open( QUrl ) = 0;
        virtual void close( void ) = 0;
        virtual void sendTextMessage( QString ) = 0;
        virtual bool isValid( void ) = 0;
        virtual bool isDisconnected( void ) = 0;
        virtual bool isConnecting( void ) = 0;

    signals:
        void connected();
        void closed();
        void textMessageReceived( QString );
        void error( QString );
};

#endif // WEBSOCKET_H
